#include <iostream>
#include "Figures.h"

int main()
{
    std::vector <GeometricFigure<double>*> figures;

    Circle<double> circle(Point<double>(0, 0), 5.0);
    Ellipse<double> ellipse(Point<double>(0, 0), 3.0, 2.0);
    Triangle<double> triangle(Point<double>(0, 0), Point<double>(3, 0), Point<double>(0, 4));
    Rectangle<double> rectangle(Point<double>(0, 0), Point<double>(3, 0), Point<double>(3, 4), Point<double>(0, 4));
    Polygon<double> polygon("bounds.txt");
    figures.push_back(&circle);
    figures.push_back(&ellipse);
    figures.push_back(&triangle);
    figures.push_back(&rectangle);
    figures.push_back(&polygon);

    for (const auto& figure : figures) {
        figure->name();
        std::cout << "Area: " << figure->calc_area() << std::endl;
        std::cout << "Perimeter: " << figure->calc_perimeter() << std::endl << "\n";
    }
}